#!/usr/bin/perl

use strict;
use warnings;

require './hutool.pl';
require './lib.pl';

my @GET_NAME    = ('renewal');
my @POST_NAME   = ('renewal');

our %GET        = &hutool::DECODE_GET(@GET_NAME);
our %POST       = &hutool::DECODE_POST(@POST_NAME);

our $log_dir    = './log/past';

our $nowfile    = sprintf('./log/now.txt');
our $logfile    = sprintf('./log/output.txt');
our $mode_file  = sprintf('./log/mode.txt');
our $list_file  = sprintf('./log/list.txt');
our $renew_file = sprintf('./log/renew.txt');

our $this       = &hutool::THIS();

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';

  $html.=&header();

  $html.=sprintf('<a href="%s">renewal</a>',$this);
  $html.=&renewal;
  $html.=&viewlog();

  $html.=&footer();

  return $html;
}

sub renewal
{
  if($POST{'renewal'} ne '' || $GET{'renewal'} ne '')
  {
    if( open(RNF,">$renew_file") )
    {
      print RNF sprintf('%d%d',time(),rand()*10);
      close(RNF);
    }
  }

  return sprintf('<form action="%s"><input type="hidden" name="renewal" value="%d"><input type="submit" value="Renewal"></form>',$this,time());
}

sub viewlog
{
  return sprintf('<div id="result"></div>');
}

sub header
{
  my($mode,$file)=@_;
  return sprintf('<html>
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <title>編集者用</title>
 <style>
  <!--
  -->
 </style>
 <script type="text/javascript" src="./http.js"></script>
 <script laguage="JavaScript">
<!--
  RnewalTime=0;
  httpObject=null;

  function renew(flag)
  {
    if(flag || check( Http_Content("./log/renew.txt"+"?"+get_time()) ) )
    {
      httpObject=Http_Content("./readfile.cgi"+"?"+"%s"+"&"+RnewalTime,log_write);
    }

  }

  //更新時間チェック関数
  function check(new_time)
  {
   //最終更新時間が前回更新時間よりも進んでいる 
    if(RnewalTime<new_time)
    {
      RnewalTime=new_time;
      return 1;
    }
    return 0;
  }

  function log_write()
  {
    if(httpObject && (httpObject.readyState == 4) && (httpObject.status == 200) )
    {
      document.getElementById("result").innerHTML=httpObject.responseText;
    }else
    {
    }
  }

  function get_time()
  {
    var now = new Date();
    return now.getHours()*10000+now.getMinutes()*100+now.getSeconds();
  }

-->
  </script>
 <link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
 <link rel="stylesheet" href="./material/style.css" type="text/css" />
</head>
<body onLoad="renew(1);setInterval(\'renew()\',1000)">
'
  ,$logfile);
}

sub footer
{
  return sprintf('</body>%s</html>%s',"\n","\n");
}
