#!/usr/bin/perl

use strict;
use warnings;

#log file
our $log_file = 'log.cgi';

our $hct='./hct.txt';

require 'hutool.pl';
require 'lib.pl';

our %TYPE  =('vote'=>'場内票数','hearer'=>'傍聴者','comment'=>'コメント','high'=>'重要','mid'=>'そうでもない','low'=>'くだらない');
our %TSTYLE=('vote'=>'vote','hearer'=>'hearer','comment'=>'low','high'=>'high','mid'=>'mid','low'=>'low');

our %GET =&hutool::DECODE_GET('page','num','mode','type','numbers');

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';

  my @numbers=split(/,/,$GET{'numbers'});
  if($GET{'page'} eq ''){$GET{'page'}=0;}

  $html.=&html_head();
  $html.=&html_list(@numbers);
  $html.=&html_foot();

  return $html;
}

sub html_list
{
  my (@numbers)=@_;
  my $html='';

  my($ct)=&hutool::OPEN_FILE($hct);

  $html.=sprintf('<div class="right">最終更新時刻 : %s</div>',&lib::print_time(time()));
  foreach(&lib::log_read(0,$log_file,0))
  {
    if($_!=0)
    {
      my %data=&lib::data_split($_);
      my $c=0;
      if($data{'type'} eq 'hearer'){$c=$ct;--$ct;}

      if(&check($data{'num'},@numbers))
      {
        $html.=&lib::decorate($data{'num'},$data{'type'},$data{'time'},$data{'name'},$data{'title'},$data{'text'},$TSTYLE{$data{'type'}},$c,0);
      }
    }
  }

  return $html;
}

sub check
{
  my($c,@numbers)=@_;
  foreach(@numbers)
  {
    if($c==$_){return 1;}
  }
  return 0;
}

sub html_head
{
  my @array=split(/,/,$GET{'numbers'});
#  foreach(@array){$_=sprintf('"%d"',$_);}

  return sprintf('<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
 <meta http-equiv="content-type" content="text/html; charset=utf-8" />
 <meta http-equiv="Expires" content="Sun, 10 Jan 1990 01:01:01 GMT" /> 
 <meta http-equiv="Cache-Control" content="no-cache" />
 <meta http-equiv="Pragma" content="no-cache" />
 <link rel="stylesheet" href="./style.css" type="text/css" />
 <title>チェック</title>
 <script type="text/javascript">
<!--

  //リストからチェックされたものを削除し、リストを更新する
  function check_list(num)
  {
    if(num>0)
    {
      var n=window.opener.del(num);
      if(n == ""){close();}
      var win=open("./check.cgi?numbers="+n,"lists");
    }
  }

-->
 </script>
 </head>
<body>
<div class="title">チェックリスト</div>

<div class="view">
');

}

sub html_foot
{
  return sprintf('</div>
</body>
</html>
');
}

