#!/usr/bin/perl

use strict;
use warnings;
use CGI::Util qw(escape unescape);

#log file
our $log_file = 'log.cgi';

our $hct='./hct.txt';

#in page max
our $page_max = 20;

our $powor_time=60;

require 'hutool.pl';
require 'lib.pl';

our %TYPE  =('vote'=>'場内票数','hearer'=>'傍聴者','comment'=>'コメント','high'=>'重要','mid'=>'そうでもない','low'=>'くだらない');
our %TSTYLE=('vote'=>'vote','hearer'=>'hearer','comment'=>'low','high'=>'high','mid'=>'mid','low'=>'low');

our %POST=&hutool::DECODE_POST('num','mode','type','name','title','text');
our %GET =&hutool::DECODE_GET('page','num','mode','type','name','title','text');

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';

  if($ENV{'QUERY_STRING'}=~/[\D]/ && $GET{'page'} eq '')
  {
    if($GET{'text'} ne '')
    {
      $POST{'type'} =unescape($GET{'type'});#Jcode->new($GET{'type'} , 'sjis')->utf8;
      $POST{'name'} =unescape($GET{'name'});#Jcode->new(GET{'name'} , 'sjis')->utf8;
      $POST{'title'}=unescape($GET{'title'});#Jcode->new($GET{'title'}, 'sjis')->utf8;
      $POST{'text'} =unescape($GET{'text'});#;#Jcode->new($GET{'text'} , 'sjis')->utf8;

      if($POST{'num'} eq '' || $POST{'num'}=~/\D/){$POST{'num'}='none';}
      &log_write($POST{'type'},$POST{'num'},$POST{'title'},$POST{'name'},$POST{'text'});
    }
    $html.=&html_head();
    $html.=sprintf('<a href="%s">移動しない場合はこちら。</a>','./index.html');
    $html.=&html_foot();
  }else
  {
    if($GET{'page'} eq ''){$GET{'page'}=0;}
    $html.=&html_list();
  }

  return $html;
}

sub html_list
{
  my $html='';

  my($ct)=&hutool::OPEN_FILE($hct);

  $html.=sprintf('<div class="right">最終更新時刻 : %s</div>',&lib::print_time(time()));
  foreach(&lib::log_read($GET{'page'},$log_file,$page_max))
  {
    if($_!=0)
    {
      my %data=&lib::data_split($_);
      my $c=0;
      if($data{'type'} eq 'hearer'){$c=$ct;--$ct;}
      $html.=&lib::decorate($data{'num'},$data{'type'},$data{'time'},$data{'name'},$data{'title'},$data{'text'},$TSTYLE{$data{'type'}},$c,$powor_time);
    }
  }

  return $html;
}

sub log_write
{
  my($in_type,$in_num,$in_title,$in_name,$in_text)=@_;
  my @line = &hutool::OPEN_FILE($log_file);

  if($in_num eq 'none')
  {#write
    my %last = &lib::data_split($line[0]);

    if($in_type eq 'hearer')
    {
      open(CT,"<$hct");
      my $ct=<CT>;
      close(CT);

      open(CT,">$hct");
      print CT $ct+1;
      close(CT);
    }

    if($in_type eq '')
    {
      $in_type='low';
    }#elsif($in_type eq 'vote')
    #{
    #  $in_text=&lib::wide2half($in_text);
    #}
    if($in_name eq ''){$in_name='名無し';}

    my $new_data = join("\t",$last{'num'}+1,time(),$in_type,$in_title,$in_name,$in_text);
    $new_data=~s/\n/<br \/>/g;
    unshift(@line,$new_data."\n");

  }else
  {#delite
    
  }

  if(-f $log_file && open(LOG,"> $log_file"))
  {
    print LOG @line;
    close(LOG);
    return 1;
  }

  return 0;
}

sub html_head
{
  return sprintf('<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
 <meta http-equiv="content-type" content="text/html; charset=utf-8" />
 <meta http-equiv="refresh" content="0 ; URL=./index.html" />
 <title>もう少しお待ち下さい</title>
 </head>
<body>
');
}

sub html_foot
{
  return sprintf('</body>
</html>
');
}

