#!/usr/bin/perl

use strict;
use warnings;

#log file
our $log_file = 'log.cgi';

our $hct='./hct.txt';

#in page max
our $page_max = 20;

our $powor_time=60;

require 'hutool.pl';
require 'lib.pl';

our %TYPE  =('vote'=>'場内票数','hearer'=>'傍聴者','comment'=>'コメント','high'=>'重要','mid'=>'そうでもない','low'=>'くだらない');
our %TSTYLE=('vote'=>'vote','hearer'=>'hearer','comment'=>'low','high'=>'high','mid'=>'mid','low'=>'low');

our %GET =&hutool::DECODE_GET('page','num','mode','type');

if($GET{'page'} eq ''){$GET{'page'}=0;}

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html='';

  $html.=&html_head();
  $html.=&html_foot();

  return $html;
}

sub log_write
{
  my($in_type,$in_num,$in_title,$in_name,$in_text)=@_;
  my @line = &hutool::OPEN_FILE($log_file);

  if($in_num eq 'none')
  {#write
    my %last = &lib::data_split($line[0]);

    if($in_type eq 'hearer')
    {
      open(CT,"<$hct");
      my $ct=<CT>;
      close(CT);

      open(CT,">$hct");
      print CT $ct+1;
      close(CT);
    }

    if($in_type eq ''){$in_type='low';}
    if($in_name eq ''){$in_name='名無し';}
    my $new_data = join("\t",$last{'num'}+1,time(),$in_type,$in_title,$in_name,$in_text);
    $new_data=~s/\n/<br \/>/g;
    unshift(@line,$new_data."\n");

  }else
  {#delite
    
  }

  if(-f $log_file && open(LOG,"> $log_file"))
  {
    print LOG @line;
    close(LOG);
    return 1;
  }

  return 0;
}

sub html_head
{
  return sprintf('<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
 <meta http-equiv="content-type" content="text/html; charset=utf-8" />
 <meta http-equiv="Expires" content="Sun, 10 Jan 1990 01:01:01 GMT" /> 
 <meta http-equiv="Cache-Control" content="no-cache" />
 <meta http-equiv="Pragma" content="no-cache" />
 <link rel="stylesheet" href="./style.css" type="text/css" />
 <title>過去ログ</title>
 <script type="text/javascript" src="./http.js"></script>
 <script type="text/javascript" src="./bbs.js"></script>
 <script type="text/javascript">
<!--

  //最終更新時間
  RnewalTime=0;
  //通信用オブジェクト
  httpObject=null;
  //更新フラグ
  flag=0;
  //インターバル用
  itimer=0;

  //更新用関数
  function renew()
  {
    httpObject=Http_Content("./index.cgi"+"?"+get_time()+"&page="+%d,log_write);
  }

  //自動更新のフラグを切り替える
  function change_flag()
  {
    if(flag==1 && itimer)
    {
      flag=0;
      clearInterval(itimer);
    }else
    {
      flag=1;
      itimer=setInterval("renew()",3000);
    }
  }

  //HTMLのロード完了時に1度だけ実行される。
  function start()
  {
    renew();
  }

  //チェックボックスをチェックされても何もしない
  function check_list(num){}

-->
 </script>
 </head>
<body onLoad="start();">
<div class="title">過去ログ</div>
<div style="float:left;">自動更新：<input type="checkbox" onclick="change_flag();" /> | ページ：</div>%s
<div class="view">
<div id="result">'
  ,$GET{'page'},&page($GET{'page'}));
}

sub page
{
  my ($page)=@_;
  my @html;
  my $now=scalar(&hutool::OPEN_FILE($log_file));
  my $ct=0;

  while($now>0)
  {
    if($ct!=$page)
    {
      push(@html,sprintf('<li class="n"><a href="%s?page=%d">%d</a></li>','./past.cgi',$ct,$ct));
    }else{
      push(@html,sprintf('<li class="s">%d</li>',$ct));
    }
    ++$ct;
    $now-=$page_max;
  }

  return join('','<ul class="tab">',@html,'</ul>');
}

sub html_foot
{
  return sprintf('</div>
</div>
</body>
</html>
');
}

