#!/usr/bin/perl

use strict;
use warnings;

require './hutool.pl';
require './lib.pl';

our $log_dir   = './log';
our $log_file='./log/output.txt';
our $mode_file = './log/mode.txt';
our $max_out_f = 7;

print "Content-type: text/html\n\n";
print &main();

sub main
{
  my $html = '';
  my ($mode)=&hutool::OPEN_FILE($mode_file);
  my ($bill,$name,$gs,$type,$t1,$t2);
  ($mode,$bill,$name,$gs,$type,$t1,$t2) = split(/[\t|\n]/,$mode);

  if($mode eq 'G')
  {#通常ログ閲覧モード
    my $tit = '';
    my $hop = '';

    if($gs eq '00')
    {
      $gs = '';
    }else
    {
      $gs = '<span class="hw">'.$gs.'</span>';
    }

    if($type eq 'G')
    {
      $tit = '議案名';
    }

    if($gs =~/([1-4][CJEMFTH])/)
    {
      $hop = sprintf('<br />　　　提出：%s%s',$gs,$name);
    }
    $html .= sprintf('<div class="gian">%s『%s』%s　　　　</div><div class="time"><span class="hw">%s</span>時<span class="hw">%s</span>分</div>',
                     ,$tit,&lib::html_hw($bill),$hop,$t1,$t2);
    $html .= &list($log_file,$mode,$type);
  }elsif($mode eq 'S')
  {#総会開始前
    $html .= &start();
  }elsif($mode eq 'E')
  {#総会開始前
    $html .= &end();
  }else
  {
  }

  return $html;
}

sub list
{
  my ($file,$mode,$type) = @_;
  my $html = '';
  my @list = &hutool::OPEN_FILE($file);
  my $ct;
  if($type eq 'V')
  {
    $ct=$max_out_f-2;
  }else
  {
    $ct=$max_out_f;
  }
  while( scalar(@list)<$ct ){unshift(@list,"0\tnone");}

  $ct=0;
  foreach(@list)
  {
    $html .= &decorate($ct,&lib::log_read($_));
    ++$ct;
  }

  return $html;
}

sub decorate
{
  my($no,$time,$type,@data) = @_;
  my $html = '';
  my $part_name = '';
  my $part_text = '';

  if( !($type) ){$type = '';}

  if($type eq 'G')
  {#議事進行
    $part_name = '<br />';
    $part_text = sprintf('◆%s◆',$data[0]);
  }elsif($type eq 'V')# || $type eq 'A' || $type eq 'R' || $type eq 'D'
  {#決議系,'L'=>'正副執行委員長選挙'
    if($data[0] eq 'W')
    {#撤回動議
      $part_name = '<br />';
      $part_text = '<br /><br />撤回動議が提出されました。';
    }else
    {
      my %tmp = ('V'=>'採決','A'=>'休会動議','R'=>'保留動議','D'=>'採決要求動議');#,'W'=>'撤回動議'
      my ($for,$against,$resalt,$s);
      $s = '';
      if($data[1]>$data[2])
      {#賛成>反対
        if($data[0] eq 'V')
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　賛成票数：<span class="hw">%s</span> ＋ <span class="hw">%s</span> = <span class="hw">%s</span>票</div>',
                             $data[1],$data[3],$data[1]+$data[3]);
        }elsif($data[0]=~/L/i)
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　信任票数：<span class="hw">%s</span>票＋議長委任<span class="hw">%s</span>票　＝　<span class="hw">%s</span>票</div>',
                             $data[1],$data[4],$data[1]+$data[4]);
        }else
        {
          $for    =sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　賛成票数：<span class="hw">%s</span>票</div>',
                             $data[1]);
        }
        if($data[0]=~/L/i)
        {
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　不信任票数：<span class="hw">%s</span>票</div>',$data[2]);
          $resalt  = '◇信任◇';
          if($data[0] eq 'L'){$s = '　執行委員長';}else{$s = '副執行委員長';}
          $s = sprintf('<div>%s候補　「%s」</div>',$s,&lib::html_hw($data[3]));
        }else
        {
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　反対票数：<span class="hw">%s</span>票</div>',$data[2]);
          $resalt  = '◇可決◇';
        }

      }elsif($data[1]<$data[2])
      {
        if($data[0]=~/L/i)
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　信任票数：<span class="hw">%s</span>票</div>',$data[1]);
        }else
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　賛成票数：<span class="hw">%s</span>票</div>',$data[1]);
        }
        if($data[0] eq 'V')
        {
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　反対票数：<span class="hw">%s</span> ＋ <span class="hw">%s</span> = <span class="hw">%s</span>票</div>',
                             $data[2],$data[3],$data[2]+$data[3]);
        }elsif($data[0]=~/L/i)
        {
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　不信任票数：<span class="hw">%s</span>票</div>',
                             $data[2]);
          $resalt  = '<div>◆不信任◆</div>';
          if($data[0] eq 'L'){$s = '　執行委員長';}else{$s = '副執行委員長';}
          $s = sprintf('<div>%s候補　「%s」</div>',$s,$data[3]);
        }else
        {
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　反対票数：<span class="hw">%s</span>票</div>',
                           $data[2]);
          $resalt  = '◆否決◆';
        }
      }else
      {
        if($data[0]=~/L/i)
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　信任票数：<span class="hw">%s</span>票</div>',$data[1]);
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　不信任票数：<span class="hw">%s</span>票</div>',$data[2]);
        }else
        {
          $for     = sprintf('<div style="margin:0px 0px 0px 2px;color:#FFD899;">　賛成票数：<span class="hw">%s</span>票</div>',$data[1]);
          $against = sprintf('<div style="margin:0px 2px 0px 0px;color:#11DDFF;">　反対票数：<span class="hw">%s</span>票</div>',$data[2]);
        }
      }
      $part_name = sprintf('<br />%s',$tmp{$data[0]});
      $part_text = sprintf('%s%s%s%s',$s,$for,$against,$resalt);
    }
  }elsif($type eq 'N')
  {#アナウンス
    $part_name = ' ';
    $part_text = &lib::html_hw($data[0]);
  }elsif($type eq 'none')
  {
  }else
  {#議事進行
    my %tmp=('Q'=>'質問','A'=>'回答','S'=>'意見','H'=>'提出者','C'=>'議長','O'=>'その他');
    my($grade,$subject,$name,$txt)=@data;
    if($txt)# ne '')
    {
      if(!(exists($tmp{$type}))){$tmp{$type}='';}
      $part_name = sprintf('%s <b>%s%s</b><br />%s',$tmp{$type},$grade,$subject,$name);
      $part_text = &lib::html_hw($txt);
    }
  }

  if($type eq 'none')
  {
    if($time == 0)
    {
      $html = sprintf(' <div class="block"></div>');
    }
  }else
  {
    if($part_name ne '' && $part_text ne '')
    {
      my $s = '';
      my $t = '';
      my($t1,$t2,$t3)=localtime($time);
      if($type eq 'V'){$s = ' id="vote"';}
      if($no<$max_out_f){$t=sprintf(' id="time%d"',$no);}
      $html = sprintf('
 <div class="block"%s>
  <span class="time"%s>%d</span>
  <div class="name">%s</div>
  <div class="text">%s</div>
 </div>
'
      ,$s,$t,$t3*10000+$t2*100+$t1,$part_name,$part_text);
    }
  }

  return $html;
}

sub start
{
  return sprintf('<div style="text-align:center;"><img src="%s" style="width:%dpx;height:%dpx;" /></div>',
                 './material/koudou_s.png',1000,1000);
}

sub end
{
  return sprintf('<div style="text-align:center;"><img src="%s" style="width:%dpx;height:%dpx;" /></div>',
                 './material/koudou_e.png',1000,1000);
}

